"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GelMetrics(ProtocolElement):
    """
    These are contractual metrics calculated by GEL  * `BaseDir`  Base
    directory of the data * `GbQ30NoDupsNoClip`: The number of missing
    genotypes * `perc_bases_ge_15x_mapQ_ge11`: Percentage of bases
    that have >=15x coverage and mapping quality >=11 * `InputDir`:
    Input dir of the data * `DirectoryType`: Illumina directory type
    version * `nBases_samtools`: number of bases from samtools *
    `FileRelativePath`: relative path of bam file * `md5checksum`: md5
    of the delivery
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "BaseDir",
        "DirectoryType",
        "FileRelativePath",
        "GbQ30NoDupsNoClip",
        "InputDir",
        "md5checksum",
        "nBases_samtools",
        "perc_bases_ge_15x_mapQ_ge11",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import metrics as metrics_1_2_4

        return {
            "org.gel.models.report.avro.GelMetrics": metrics_1_2_4.GelMetrics,
        }

    __slots__ = [
        "BaseDir",
        "DirectoryType",
        "FileRelativePath",
        "GbQ30NoDupsNoClip",
        "InputDir",
        "md5checksum",
        "nBases_samtools",
        "perc_bases_ge_15x_mapQ_ge11",
    ]

    def __init__(
        self,
        BaseDir,
        DirectoryType,
        FileRelativePath,
        GbQ30NoDupsNoClip,
        InputDir,
        md5checksum,
        nBases_samtools,
        perc_bases_ge_15x_mapQ_ge11,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_4.GelMetrics model.

        :param BaseDir:
        :type BaseDir: str
        :param DirectoryType:
        :type DirectoryType: str
        :param FileRelativePath:
        :type FileRelativePath: str
        :param GbQ30NoDupsNoClip:
        :type GbQ30NoDupsNoClip: double
        :param InputDir:
        :type InputDir: str
        :param md5checksum:
        :type md5checksum: str
        :param nBases_samtools:
        :type nBases_samtools: double
        :param perc_bases_ge_15x_mapQ_ge11:
        :type perc_bases_ge_15x_mapQ_ge11: float
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.4"
